Binary Search : Median of two sorted arrays of different sizes.

  Рет қаралды 549,247

Tushar Roy - Coding Made Simple

Tushar Roy - Coding Made Simple

Күн бұрын

Пікірлер: 732
@nik220287
@nik220287 5 жыл бұрын
Man the way you explained it in the first 5 minutes just clarified everything. Thanks. Great video!
@meganlee5897
@meganlee5897 4 жыл бұрын
Brilliant video and explanation! One minor change to the 1st example:initialization: 1) pick smaller len 2) start = 0, end = len, binary search the len of left size of X e.g with the first example: 1st round lo = 0, hi = 5, mid = lo + (hi - lo) / 2 = 2 2nd round lo = mid + 1 = 3, hi = 5
@shaziasamreen8584
@shaziasamreen8584 3 жыл бұрын
Even after 5 years your video is best for this problem.Thank you so much for wonderful Explaination
@barmalini
@barmalini 5 жыл бұрын
I paused the video at 20:12 and now going to solve the problem at leetcode myself, thank you so much Tushar, your help for the rest of us who have never graduated from the CS but still want to become a sane programmer is invaluable
@dakshays6375
@dakshays6375 5 жыл бұрын
Damn !!! How did anyone come up with such an Algorithm
@程龙-b1w
@程龙-b1w 5 жыл бұрын
I was plagued by this problem for a very long time, you made it crystal clear, sir. Thank you!
@jessica_1811
@jessica_1811 Жыл бұрын
came to "like" this video only found out that I have "liked" this video 4 years ago when I was looking for my last job. Thank you Tushar.
@rushivt
@rushivt 4 ай бұрын
I have seen many other videos for this problem, but yours is the one that made me follow every step clearly. Thank you!
@umairalvi7382
@umairalvi7382 4 жыл бұрын
People like me wouldnt understand this video in one time,you gotta watch it multiple times ,read about the problem solving strategy then you will get the problem. He has explained in a very good manner
@shrimatkapoor2200
@shrimatkapoor2200 4 жыл бұрын
I love when he says "once it hits you" like some kind of drug or something
@Alex7nt
@Alex7nt 3 жыл бұрын
@Kayden Khalil Lol, that is scam! fake accounts
@nishantkumar1149
@nishantkumar1149 3 жыл бұрын
It's a better than a drug and the dopamine released on solving questions is sickkkk.
@JCatharsis
@JCatharsis 3 жыл бұрын
It finally hit me I'm so high rn
@nikhileshkumar9126
@nikhileshkumar9126 3 жыл бұрын
don't do drugs bro. It's harmful.
@ncba
@ncba 2 жыл бұрын
Quite a common phrase
@abhijeetpatnaik5494
@abhijeetpatnaik5494 2 жыл бұрын
I can't stress enough, how clear this video explanation is. Really loving your work, and it's very very helpful.
@DonchenkoNadia
@DonchenkoNadia 3 жыл бұрын
Tushar, thank you so much! You explained it perfectly! If someone need solution in Python, here it is: class Solution: def findMedianSortedArrays(self, nums1: List[int], nums2: List[int]) -> float: if len(nums1) > len(nums2): return self.findMedianSortedArrays(nums2, nums1); x = len(nums1) y = len(nums2) low = 0 high = x while low
@gunahawk6893
@gunahawk6893 2 жыл бұрын
clean implementation good job
@beer_bandhu
@beer_bandhu 6 жыл бұрын
This is amazing. I was so confused by this problem, you explained it so succinctly. Thanks
@soulmusic6530
@soulmusic6530 4 жыл бұрын
after reading multiple explanations, this one finally made me understand how to think. Thanks for the video.
@double_courage57
@double_courage57 4 жыл бұрын
@4:30 - I took a second to understand this : Think of the final sorted array (without duplicates) and draw a median line. We need to find the average of numbers which are immediately to the left and right of that median line. If x2 is immediately to the left of the median line, it has to be greater than y5 (remember final array is sorted). Similarly, if y6 is to the right of the median line it has to be lesser than x3. Hope this helps someone!
@TheBuzoTechie
@TheBuzoTechie 2 жыл бұрын
thanks for the extra intuition :)
@return1210
@return1210 Жыл бұрын
Thanks a lot!
@sanjitselvan5348
@sanjitselvan5348 Жыл бұрын
I went through 5 videos before landing here and finally understanding the intuition behind the solution. Thank you!
@wengao6544
@wengao6544 Жыл бұрын
This video is definitely the most effective one in providing a clear explanation of the algorithm
@uzdik.student
@uzdik.student 3 жыл бұрын
00:00 Introduction 01:39 Solution 06:19 Example 1 14:35 Example 2 20:11 Code
@abhinavgarg5611
@abhinavgarg5611 3 жыл бұрын
Thanks buddy😊
@marshallxu7480
@marshallxu7480 4 жыл бұрын
this is the best video of all time, it brings happiness. thank you!
@remixisthis
@remixisthis 5 жыл бұрын
Very well done detailed explanation. Much better than the LeetCode solution example. Thanks for taking the time to make this!
@balajim7801
@balajim7801 4 жыл бұрын
Clear explanation. Thanks. A small error, 8:33 value of "end" should be 5 (size of small array). I followed just your example and coded, everything was right but failing always, until I watched your code & realized that end should have initial value of smallest array's length.
@eskuAdradit0
@eskuAdradit0 3 жыл бұрын
any clear explanation on why would we do it like this? is it the same reasoning behind adding + 1 to the sum of both arrays before dividing by two?
@haoyuwu894
@haoyuwu894 2 жыл бұрын
@@eskuAdradit0 I think it's because in some cases we can have all the elements in x on the left side. He mentioned that partitionX is "the number of elements partitioned to the left in x." So in those cases, partitionX can be the size of the small array. Consider this example: arrayX: [1, 2, 3, 4] and arrayY: [5, 6, 7, 8]. All the elements in x are smaller than elements in y. Hope this helps.
@rkalyankumar
@rkalyankumar 3 жыл бұрын
The best possible explanation of the problem I've seen so far. I have now clear idea on how median of two sorted array algorithm works using binary search & partitioning arrays. Good stuff!
@SourabhCA
@SourabhCA 5 жыл бұрын
Spent a lot of time trying to understand this from leetcode solutions and discussion. And you video explained it in 5 minutes
@ADITYAKUMAR-yd3ow
@ADITYAKUMAR-yd3ow 7 жыл бұрын
Perfect explanation, initially I though it would be difficult for me. But gradually you made me understand in only one go. Thanks 😀
@tusharroy2525
@tusharroy2525 7 жыл бұрын
Great.
@anondoggo
@anondoggo 2 жыл бұрын
Beautiful solution, thank you so much! I can't believe how close I was to the solution, I wished I pushed myself a bit harder, but this was a great educational experience. Thanks again!
@suvirsaurav5587
@suvirsaurav5587 5 жыл бұрын
In the first example, the end value at the start should be 5 as we can have a partition when all the 5 elements of array X will be on the left side.
@yoosufahmadh3945
@yoosufahmadh3945 4 жыл бұрын
Repeat watching the first 6 minutes until you get it. Totally helps. Thank you so much. You simply put it
@kimmeng6939
@kimmeng6939 5 жыл бұрын
7:18 end should be 5 not 4 because we are searching which position we want to cut.
@prakashtiwari7834
@prakashtiwari7834 4 жыл бұрын
YES! Had the last element of first array been 10 instead of 15, the algorithm would've broken at 13:45. Anyways, the explanation was awesome.
@everydayleetcode2961
@everydayleetcode2961 4 жыл бұрын
@@prakashtiwari7834 I was wondering why did he take end as 4 and read this comment ! Thanks a lot !
@emilyhuang2759
@emilyhuang2759 4 жыл бұрын
But why not 4? The 5th index is empty....so I would think the end is 4...?
@sharmamukul938
@sharmamukul938 4 жыл бұрын
@@emilyhuang2759 Exactly even i'm not able to figure out why the end should be 5 and not 4 as it is clearly mentioned in the video that first array has 5 elements in total.
@varunwalia95
@varunwalia95 3 жыл бұрын
@@sharmamukul938 it should be the size of the array not index that is to be taken as high element according to code.
@maxfeldman6654
@maxfeldman6654 6 жыл бұрын
probably one of the best explanations i have seen so far, SUBSCRIBED!
@Destiny22377
@Destiny22377 5 жыл бұрын
Great solution. Not every detail was explained but as everyone else was saying this is probably the best solution on the net and if not it is one of the best ! The missing details can be inferred
@bewareofnikhil
@bewareofnikhil 2 жыл бұрын
What a precise and correct explanation of the algorithm! Thanks for making and sharing this video, Tushar.
@somiljain896
@somiljain896 5 ай бұрын
The best explaination with perfect testcases that I found for this question on Internet. Thank you!
@sshangrou8799
@sshangrou8799 6 жыл бұрын
thanks very much.it took me long time to think the algorithm on leetcode, your explanation is so clear and concise.Very nice
@arthamsreenivas8858
@arthamsreenivas8858 5 жыл бұрын
Tushar Sir, you literally saved my time with crystal clear explanation on this problem.
@gauravghosh6562
@gauravghosh6562 Жыл бұрын
this is the best channel for coding hand down
@saurabhzalke4232
@saurabhzalke4232 4 жыл бұрын
So elegant and simple. One of the best tutorial ever! Keep it up.
@jaatharsh
@jaatharsh 4 жыл бұрын
don't think there are words to express my gratitude towards your hard work in making such bloody awesome videos @TusharRoy your videos indeed are class apart & blessing for someone who wants to gain in-depth knowledge on DSA.
@CodingWithPrakash_
@CodingWithPrakash_ 4 жыл бұрын
kzbin.info/www/bejne/jV64kp-wjrt4n7M
@stanleyakachukwu7881
@stanleyakachukwu7881 2 жыл бұрын
Brother, you have done well in explaining this. Thanks! I wanted to abandon this until I saw your video. With what I have known now I can go and write it myself until I pass it without looking at random solutions across the internet. I have subscribed for more.
@ahasunos5914
@ahasunos5914 3 жыл бұрын
Thank you so much Tushar. This explanation will last for generations.
@sanjayizardar2263
@sanjayizardar2263 4 жыл бұрын
Perfectly explained... Found most useful among all the available videos on KZbin for median in two sorted arrays.
@PhoenixRisingFromAshes471
@PhoenixRisingFromAshes471 4 жыл бұрын
Jahapana tussi great .........sir i read a lot about this problem solution everywhere but finally came to understand from your video only...you made a very tricky concept so simple to understand
@seekingWisdomAcrossWorlds
@seekingWisdomAcrossWorlds 3 жыл бұрын
I was so confuse how to solve this without taking care of corner cases as extra, your explanation was awesome. Thanks
@vikasaggarwal2834
@vikasaggarwal2834 2 жыл бұрын
i usually don't comments on videos but your method of explaining made me comment on this... Superb video boss..
@李克弱
@李克弱 5 жыл бұрын
this is the best explan I ve ever seen step by step with details, thank you
@achyutaarjunneupane1154
@achyutaarjunneupane1154 7 жыл бұрын
great sir, got it in single explanation, I looked all over for over 4 hr
@tusharroy2525
@tusharroy2525 7 жыл бұрын
+achyut aarjunneupane nice
@j50313j50313
@j50313j50313 4 жыл бұрын
You save my life. Just watch for 8 minutes and come up with a solution by myself!
@pawandeepchor89
@pawandeepchor89 6 жыл бұрын
Excellent !! Nothing more one can do to explain this problem :) Thanks for sharing it buddy !! You are a star, keep up the good work, cheers !!
@Chandan-io3jm
@Chandan-io3jm 7 жыл бұрын
Best Channel for Data Structure && Algorithms !
@shwetankgupta
@shwetankgupta 5 жыл бұрын
Finally, I understood the crux of this problem. Thanks for the enlightenment.
@韓覲
@韓覲 3 жыл бұрын
I can never figure it out without this video.
@kumarsamaksha7207
@kumarsamaksha7207 3 жыл бұрын
noob
@mukut5ul
@mukut5ul 3 жыл бұрын
These videos are great equivalent to full computer science degree content
@stratonov
@stratonov 2 жыл бұрын
Beautiful lovely brilliantly handled edge cases
@sharatchandra9198
@sharatchandra9198 4 жыл бұрын
Most Beautiful explanation and solution. My deepest gratitude to all your videos.
@bharathik6479
@bharathik6479 4 жыл бұрын
Crystal clear explanation , Bro. You are helping a lot of people, Please Keep up the good Work.
@vishwajeetpawar5074
@vishwajeetpawar5074 3 жыл бұрын
Thanks Tushar.Your explanation helped a lot to understand the depth of logic and algorithm behind this question.
@dongshuowu3454
@dongshuowu3454 5 жыл бұрын
Thank you for the wonderful video. I was stuck for a long time until you made it co clear to me.
@subhodeepganguly2575
@subhodeepganguly2575 4 жыл бұрын
Very Nice Explanation. One of the best videos of Tushar
@dzungdev
@dzungdev 5 жыл бұрын
Thank you very much for your great explanation. I learn a lot from you, not only the code but the way to explain the problem.
@MykolaDolgalov
@MykolaDolgalov 4 жыл бұрын
*EDIT:* Thank you for the video. I watched it carefully, then coded the solution from memory. And then I compared to your solution, and mine is a little simpler and easier to understand (code is in the first comment). *Initial comment* 14:41 here it is obvious from the data that we must compare the rightmost and leftmost elements to see if the values in the arrays even overlap in range. If they don't we should skip the binary search and just treat them as one continuous sorted array, and find the median in it directly. Thank you for the wonderful videos.
@MykolaDolgalov
@MykolaDolgalov 4 жыл бұрын
A somewhat simpler and easier to follow code: public double findMedianSortedArrays(int[] nums1, int[] nums2) { int len1 = nums1.length; int len2 = nums2.length; int res = 0; if(len2 < len1) return findMedianSortedArrays(nums2, nums1); int partitionX = len1 / 2; int low = 0; int high = len1; while(low 0 ? nums1[partitionX - 1] : Integer.MIN_VALUE; int num1R = partitionX < len1 ? nums1[partitionX] : Integer.MAX_VALUE; int num2L = partitionY > 0 ? nums2[partitionY - 1] : Integer.MIN_VALUE; int num2R = partitionY < len2 ? nums2[partitionY] : Integer.MAX_VALUE; if(num1L = num2L) { // found correct comb if((len1 + len2) % 2 != 0) return Math.max(num1L, num2L); else return 1.0*(Math.max(num1L, num2L) + Math.min(num1R, num2R)) / 2.0; } else if(num1R < num2L) { // need to move to the right low = ++partitionX; } else high = --partitionX; } return Double.MIN_VALUE; }
@techbarikcom
@techbarikcom 4 жыл бұрын
You are making my life a lot easier! May God bless you
@himangshubiswas542
@himangshubiswas542 Жыл бұрын
Because of you I am going to solve this problem otherwise I thought I will skip it, thank you
@tvbuff
@tvbuff 3 жыл бұрын
You truly are making coding simple !
@zaheenrahman6608
@zaheenrahman6608 6 жыл бұрын
My boy Tushar Roy! Earned yourself a sub! Gonna help my algo course so much
@ankush363
@ankush363 4 жыл бұрын
I got asked this question in an interview .Before this video i ignored this question multiple times due to which i was not able to answer this in interview .After getting rejected from the interview i came here and i feel how can a person come up with such a solution in 45 minute interview and code it properly.But The solution is very nice.
@CodingWithPrakash_
@CodingWithPrakash_ 4 жыл бұрын
kzbin.info/www/bejne/jV64kp-wjrt4n7M
@lukaslehmann9708
@lukaslehmann9708 2 жыл бұрын
Hi Sir, thanks for your great and detailed explanation...just had watched serveral videos and explanations before I saw your video...and finally I understood how it worked...It is really awsome that you used these examples to illustrate the problem (including the edge case) and in your code you also wrote so many annotations...I really appreciate your effort and great work.
@rahul-patil
@rahul-patil 5 жыл бұрын
15:24 If there are n element then we can partition that array in n+1 no. of ways. E.G 4 elements then we partition it in. 1) 0 - 4 2) 1 - 3 3) 2 - 2 4) 3 - 1 5) 4 - 0
@krishnabhagavan9621
@krishnabhagavan9621 4 жыл бұрын
0-4 and 4-0 results in same arrays
@ИванЕлисеев-р1з
@ИванЕлисеев-р1з 3 жыл бұрын
Thank you so much. Your explanation is the best. Only with you I understood how to solve that problem.
@nabidulalam6956
@nabidulalam6956 4 жыл бұрын
Simple and elegant explanation. Hats off.
@DimpleSharma-jo9gf
@DimpleSharma-jo9gf 4 жыл бұрын
Such a great explanation! Love how you simplify things. Thanks a lot!!!
@gauravdudeja
@gauravdudeja 6 жыл бұрын
After watching 2 times it quite easy to understand. Keep up the good work Tushar.
@hawaijarjs7496
@hawaijarjs7496 4 жыл бұрын
Thanks Bro for the excellent explanation! It is crystal clear now how the logic works for both odd/even scenarios. Appreciate your time. Cheers!
@pi3ni0
@pi3ni0 2 жыл бұрын
Thanks, good explanation. I was looking for different resources, but it was the best so far :)
@semurgx
@semurgx 3 жыл бұрын
this one of the best explanation on youtube, awesome!
@35sherminator
@35sherminator 5 жыл бұрын
Legendary. Very crisp and clear approach. Thank you very very much!
@കള്ള_ചക്കോ
@കള്ള_ചക്കോ 3 жыл бұрын
give this man a medal
@Avinashkumar-xt4zq
@Avinashkumar-xt4zq 3 жыл бұрын
Best explanation present on the Internet!
@JaySolanki91
@JaySolanki91 5 жыл бұрын
Simply Amazing !!! This algorithm was really helpful and you gave good examples to solve it. Especially the one in which you covered the corner cases.
@_PRITIJHA
@_PRITIJHA 4 жыл бұрын
Your channel solves all my doubt
@kshitijtakarkhede7833
@kshitijtakarkhede7833 4 ай бұрын
Crystal clear sir
@WS-lv4kk
@WS-lv4kk 5 жыл бұрын
For odd total array size, instead of adding 1 in the (x+y+1)/2 and taking the max of the left half, I think you can just do (x+y)/2 and take min of the right half.
@pavithranravichandiran6720
@pavithranravichandiran6720 2 жыл бұрын
Great observation!
@mrinmoypaul6810
@mrinmoypaul6810 3 жыл бұрын
Tushar Sir tumi Bhogowan, Love from West Bengal
@RITIKSINGH-re5ne
@RITIKSINGH-re5ne 3 жыл бұрын
The explanation so deep I forgot what was the question.
@SonuSonu-tk5pk
@SonuSonu-tk5pk 7 жыл бұрын
very neat and excellent explanation
@tusharroy2525
@tusharroy2525 7 жыл бұрын
Thanks
@niksmachnih264
@niksmachnih264 2 жыл бұрын
The best explanation that I ever heard
@shashikantdivekar7839
@shashikantdivekar7839 3 жыл бұрын
Very good explanation. Thank you Tushar Roy.
@priyanka.sarkar
@priyanka.sarkar 6 жыл бұрын
Hats off sir...I am really overwhelmed by the way you explained this algorithm and made it so easy and simple...(y) Thank you so much...:-)
@jinny5025
@jinny5025 4 жыл бұрын
wow there's nothing more than clearer than this! thanks :) you just saved my time
@priyankachauhan0112
@priyankachauhan0112 5 жыл бұрын
Hey Tushar, You make complicated problem look so simple and easy. Awesome job.
@neerajlajpal8858
@neerajlajpal8858 4 жыл бұрын
Amazing video. Clear and concise explanation
@13379056
@13379056 3 жыл бұрын
With brute force you can actually achieve O((m+n)/2) with constant space. Just don't store the merged elements and end the merge once your reach the m+n/2 element
@deleteduser792ba
@deleteduser792ba 2 жыл бұрын
That is true but there is no such thing as O((m+n)/2) since 1/2 is a constant and it gets eradicated in the asymptotic analysis. Nonetheless, what you have proposed is a "better" linear solution.
@msteja
@msteja 3 жыл бұрын
Geniusly explained the algo 🙏🏻👏🏻
@siddharthkhandelwal933
@siddharthkhandelwal933 Жыл бұрын
Very well explained, the code is very clear and precise. Thanks
@DhananjayTyagi24
@DhananjayTyagi24 5 жыл бұрын
The best explanation so far.
@NeoMennon
@NeoMennon 5 жыл бұрын
Tushar you are awesome! I have watched few video about this question, yours is the most intuitive one
@ujjvalsharma5055
@ujjvalsharma5055 3 жыл бұрын
One of the best explaination!!. Great work. Keep making more video :)
@kalashnikov203
@kalashnikov203 4 жыл бұрын
The best explanation on this topic.
@rajasekharmaddineni1069
@rajasekharmaddineni1069 4 жыл бұрын
To move left or Right of array, should increase or decrease on "start" and "end" variables. not partition x because it's failing in below case [1,2,3,4,6] [5]
@GeetThaker
@GeetThaker 4 жыл бұрын
it is working. remember you have to make 2nd array as X in example.
@jacobstech1777
@jacobstech1777 3 жыл бұрын
Simply the best explanation.
@depression_plusplus6120
@depression_plusplus6120 Жыл бұрын
If you're reading this...and belong to non cs branch...i really really hope and pray to god that you end up successful with a good job at the end, unlike me. Who always strived hard, did over 1200+ question. Cracked till interview, but always got rejected because of my branch or becoz of communication skills...i hope that never happens to you atleast! They say, "Prayers and curses of a hurt sad person never go unlistened". I hope my prayers becomes a blessing for you!...
@depression_plusplus6120
@depression_plusplus6120 10 ай бұрын
Bro...just give up... you're no good...just do anything at this point...forget coding😂😂
@abhinavmiglani6587
@abhinavmiglani6587 5 жыл бұрын
The variable end should be input length of nums 1, Consider case: nums1 = [1, 3] nums2 = [2]
Skyline Problem
22:54
Tushar Roy - Coding Made Simple
Рет қаралды 194 М.
СКОЛЬКО ПАЛЬЦЕВ ТУТ?
00:16
Masomka
Рет қаралды 3,5 МЛН
How Many Balloons To Make A Store Fly?
00:22
MrBeast
Рет қаралды 147 МЛН
Median of Two Sorted Arrays - Binary Search - Leetcode 4
22:22
Trie Data Structure
19:40
Tushar Roy - Coding Made Simple
Рет қаралды 412 М.
System Design : Design a service like TinyUrl
24:10
Tushar Roy - Coding Made Simple
Рет қаралды 574 М.
How to STUDY so FAST it feels like CHEATING
8:03
The Angry Explainer
Рет қаралды 1,8 МЛН
How to: Work at Google - Example Coding/Engineering Interview
24:02
Life at Google
Рет қаралды 7 МЛН
Lowest Common Ancestor Binary Tree
11:08
Tushar Roy - Coding Made Simple
Рет қаралды 252 М.
СКОЛЬКО ПАЛЬЦЕВ ТУТ?
00:16
Masomka
Рет қаралды 3,5 МЛН